﻿#pragma once

#include "CoreMinimal.h"
#include "GenericGraph.h"
#include "DialogueTree.generated.h"

USTRUCT(BlueprintType)
struct FDialogueCharacter
{
	GENERATED_BODY()

	UPROPERTY(BlueprintReadOnly, EditDefaultsOnly, Category = "Dialogue")
	FName CharacterName;
	UPROPERTY(BlueprintReadOnly, EditDefaultsOnly, Category = "Dialogue")
	UTexture2D* DialogueCharacterPortrait;
	UPROPERTY(BlueprintReadOnly, EditDefaultsOnly, Category = "Node")
	FLinearColor DialogueNodeBgColor;
};

UCLASS(Blueprintable)
class ENDLESSVENDETTA_API UDialogueTree : public UGenericGraph
{
	GENERATED_BODY()

public:
	UDialogueTree();

	UPROPERTY(EditDefaultsOnly, Category = "Dialogue")
	FDialogueCharacter Character1;
	UPROPERTY(EditDefaultsOnly, Category = "Dialogue")
	FDialogueCharacter Character2;
	UPROPERTY(EditDefaultsOnly, Category = "Dialogue")
	FDialogueCharacter Character3;
	UPROPERTY(EditDefaultsOnly, Category = "Dialogue")
	FDialogueCharacter Character4;
};
